diff --git a/gcc/ChangeLog.graphite b/gcc/ChangeLog.graphite
index efc4de9..d20b746 100644
--- a/gcc/ChangeLog.graphite
+++ b/gcc/ChangeLog.graphite
@@ -1,3 +1,14 @@
+2010-12-29  Sebastian Pop  <sebastian.pop@amd.com>
+
+	* Makefile.in (graphite-opencl-codegen.o): Update dependences.
+	(graphite-opencl-meta-clast.o): Same.
+	(graphite-opencl.o): Same.
+	(refined-regions.o): Same.
+	* graphite-opencl-codegen.c: Do not include unnecessary .h files.
+	* graphite-opencl-meta-clast.c: Same.
+	* graphite-opencl.c: Same.
+	* refined-regions.c: Same.
+
 2010-12-27  Sebastian Pop  <sebastian.pop@amd.com>
 
 	* graphite-opencl-codegen.c: Use FOR_EACH_VEC_ELT.
diff --git a/gcc/Makefile.in b/gcc/Makefile.in
index 018276a..cde1ef2 100644
--- a/gcc/Makefile.in
+++ b/gcc/Makefile.in
@@ -2709,33 +2709,19 @@ graphite-sese-to-poly.o : graphite-sese-to-poly.c $(CONFIG_H) \
    $(SYSTEM_H) coretypes.h $(TREE_FLOW_H) $(TREE_DUMP_H) $(CFGLOOP_H) \
    $(TREE_DATA_REF_H) domwalk.h sese.h graphite-ppl.h graphite-poly.h \
    graphite-sese-to-poly.h
-refined-regions.o: refined-regions.c $(CONFIG_H) $(SYSTEM_H) coretypes.h \
-   $(TM_H) $(BASIC_BLOCK_H) $(TIMEVAR_H) $(BITMAP_H) domwalk.h $(TREE_PASS_H) \
-   refined-regions.h
-graphite-opencl-codegen.o: graphite-opencl-codegen.c $(CONFIG_H) \
-   $(SYSTEM_H) coretypes.h $(TM_H) \
-   $(GGC_H) $(TREE_H) $(RTL_H) $(BASIC_BLOCK_H) $(DIAGNOSTIC_H) $(TOPLEV_H) \
-   $(TREE_FLOW_H) $(TREE_DUMP_H) $(TIMEVAR_H) $(CFGLOOP_H) $(GIMPLE_H) \
-   $(TREE_DATA_REF_H) tree-pass.h graphite.h graphite-opencl.h\
-   pointer-set.h value-prof.h graphite-ppl.h sese.h \
-   graphite-scop-detection.h graphite-clast-to-gimple.h graphite-poly.h \
-   graphite-dependences.h
-graphite-opencl-meta-clast.o: graphite-opencl-meta-clast.c $(CONFIG_H) \
-   $(SYSTEM_H) coretypes.h $(TM_H) \
-   $(GGC_H) $(TREE_H) $(RTL_H) $(BASIC_BLOCK_H) $(DIAGNOSTIC_H) $(TOPLEV_H) \
-   $(TREE_FLOW_H) $(TREE_DUMP_H) $(TIMEVAR_H) $(CFGLOOP_H) $(GIMPLE_H) \
-   $(TREE_DATA_REF_H) tree-pass.h graphite.h graphite-opencl.h\
-   pointer-set.h value-prof.h graphite-ppl.h sese.h \
-   graphite-scop-detection.h graphite-clast-to-gimple.h graphite-poly.h \
-   graphite-dependences.h
-graphite-opencl.o: graphite-opencl.c graphite-opencl-functions.def $(CONFIG_H) \
-   $(SYSTEM_H) coretypes.h $(TM_H) \
-   $(GGC_H) $(TREE_H) $(RTL_H) $(BASIC_BLOCK_H) $(DIAGNOSTIC_H) $(TOPLEV_H) \
-   $(TREE_FLOW_H) $(TREE_DUMP_H) $(TIMEVAR_H) $(CFGLOOP_H) $(GIMPLE_H) \
-   $(TREE_DATA_REF_H) tree-pass.h graphite.h graphite-opencl.h\
-   pointer-set.h value-prof.h graphite-ppl.h sese.h \
-   graphite-scop-detection.h graphite-clast-to-gimple.h graphite-poly.h \
-   graphite-dependences.h
+refined-regions.o : refined-regions.c $(CONFIG_H) $(SYSTEM_H) coretypes.h \
+   $(BASIC_BLOCK_H) $(BITMAP_H) domwalk.h $(TREE_PASS_H) refined-regions.h
+graphite-opencl-codegen.o : graphite-opencl-codegen.c $(CONFIG_H) \
+   $(SYSTEM_H) coretypes.h $(TREE_FLOW_H) $(CFGLOOP_H) $(TREE_DATA_REF_H) \
+   $(TREE_PASS_H) sese.h gimple-pretty-print.h graphite-ppl.h graphite-poly.h \
+   graphite-clast-to-gimple.h graphite-opencl.h
+graphite-opencl-meta-clast.o : graphite-opencl-meta-clast.c $(CONFIG_H) \
+   $(SYSTEM_H) coretypes.h $(TREE_FLOW_H) $(CFGLOOP_H) $(TREE_DATA_REF_H) \
+   $(TREE_PASS_H) sese.h gimple-pretty-print.h graphite-ppl.h graphite-poly.h \
+   graphite-clast-to-gimple.h graphite-dependences.h graphite-opencl.h
+graphite-opencl.o : graphite-opencl.c graphite-opencl-functions.def $(CONFIG_H) \
+   $(SYSTEM_H) coretypes.h $(TREE_FLOW_H) $(CFGLOOP_H) $(TREE_DATA_REF_H) \
+   $(TREE_PASS_H) sese.h output.h
 tree-vect-loop.o: tree-vect-loop.c $(CONFIG_H) $(SYSTEM_H) coretypes.h \
    $(TM_H) $(GGC_H) $(TREE_H) $(BASIC_BLOCK_H) $(DIAGNOSTIC_H) $(TREE_FLOW_H) \
    $(TREE_DUMP_H) $(CFGLOOP_H) $(CFGLAYOUT_H) $(EXPR_H) $(RECOG_H) $(OPTABS_H) \
diff --git a/gcc/graphite-opencl-codegen.c b/gcc/graphite-opencl-codegen.c
index e2c1757..891fef0 100644
--- a/gcc/graphite-opencl-codegen.c
+++ b/gcc/graphite-opencl-codegen.c
@@ -23,40 +23,21 @@
 #include "config.h"
 #include "system.h"
 #include "coretypes.h"
-#include "tm.h"
-#include "ggc.h"
-#include "tree.h"
-#include "rtl.h"
-#include "basic-block.h"
-#include "diagnostic.h"
 #include "tree-flow.h"
-#include "toplev.h"
-#include "tree-dump.h"
-#include "timevar.h"
 #include "cfgloop.h"
 #include "tree-chrec.h"
 #include "tree-data-ref.h"
 #include "tree-scalar-evolution.h"
 #include "tree-pass.h"
-#include "domwalk.h"
-#include "value-prof.h"
-#include "pointer-set.h"
-#include "gimple.h"
 #include "sese.h"
-#include "output.h"
-#include "hashtab.h"
 #include "gimple-pretty-print.h"
-#include "tree.h"
 
 #ifdef HAVE_cloog
 #include "cloog/cloog.h"
 #include "ppl_c.h"
 #include "graphite-ppl.h"
-#include "graphite.h"
 #include "graphite-poly.h"
-#include "graphite-scop-detection.h"
 #include "graphite-clast-to-gimple.h"
-#include "graphite-dependences.h"
 #include "dyn-string.h"
 #include "graphite-opencl.h"
 
diff --git a/gcc/graphite-opencl-meta-clast.c b/gcc/graphite-opencl-meta-clast.c
index 3e18bfc..256ccc2 100644
--- a/gcc/graphite-opencl-meta-clast.c
+++ b/gcc/graphite-opencl-meta-clast.c
@@ -23,38 +23,20 @@
 #include "config.h"
 #include "system.h"
 #include "coretypes.h"
-#include "tm.h"
-#include "ggc.h"
-#include "tree.h"
-#include "rtl.h"
-#include "basic-block.h"
-#include "diagnostic.h"
 #include "tree-flow.h"
-#include "toplev.h"
-#include "tree-dump.h"
-#include "timevar.h"
 #include "cfgloop.h"
 #include "tree-chrec.h"
 #include "tree-data-ref.h"
 #include "tree-scalar-evolution.h"
 #include "tree-pass.h"
-#include "domwalk.h"
-#include "value-prof.h"
-#include "pointer-set.h"
-#include "gimple.h"
 #include "sese.h"
-#include "output.h"
-#include "hashtab.h"
-#include "tree.h"
 #include "gimple-pretty-print.h"
 
 #ifdef HAVE_cloog
 #include "cloog/cloog.h"
 #include "ppl_c.h"
 #include "graphite-ppl.h"
-#include "graphite.h"
 #include "graphite-poly.h"
-#include "graphite-scop-detection.h"
 #include "graphite-clast-to-gimple.h"
 #include "graphite-dependences.h"
 #include "dyn-string.h"
diff --git a/gcc/graphite-opencl.c b/gcc/graphite-opencl.c
index 09656f3..7a477ca 100644
--- a/gcc/graphite-opencl.c
+++ b/gcc/graphite-opencl.c
@@ -49,29 +49,14 @@
 #include "config.h"
 #include "system.h"
 #include "coretypes.h"
-#include "tm.h"
-#include "ggc.h"
-#include "tree.h"
-#include "rtl.h"
-#include "basic-block.h"
-#include "diagnostic.h"
 #include "tree-flow.h"
-#include "toplev.h"
-#include "tree-dump.h"
-#include "timevar.h"
 #include "cfgloop.h"
 #include "tree-chrec.h"
 #include "tree-data-ref.h"
 #include "tree-scalar-evolution.h"
 #include "tree-pass.h"
-#include "domwalk.h"
-#include "value-prof.h"
-#include "pointer-set.h"
-#include "gimple.h"
 #include "sese.h"
 #include "output.h"
-#include "hashtab.h"
-#include "tree.h"
 
 /* Variable, which holds OpenCL context.  */
 static GTY(()) tree h_context;
@@ -86,9 +71,7 @@ static GTY(()) tree h_program;
 #include "cloog/cloog.h"
 #include "ppl_c.h"
 #include "graphite-ppl.h"
-#include "graphite.h"
 #include "graphite-poly.h"
-#include "graphite-scop-detection.h"
 #include "graphite-clast-to-gimple.h"
 #include "graphite-dependences.h"
 #include "dyn-string.h"
diff --git a/gcc/refined-regions.c b/gcc/refined-regions.c
index aa53a9b..946dec3 100644
--- a/gcc/refined-regions.c
+++ b/gcc/refined-regions.c
@@ -22,9 +22,7 @@ along with GCC; see the file COPYING3.  If not see
 #include "config.h"
 #include "system.h"
 #include "coretypes.h"
-#include "tm.h"
 #include "basic-block.h"
-#include "timevar.h"
 #include "bitmap.h"
 #include "domwalk.h"
 #include "tree-pass.h"